#ifndef CAPTUS_H
#define CAPTUS_H
#include "mbed.h"
#include "math.h"

// Nom du fichier : captUS.h
#define LONGUEUR_TAB 2000
#define LARGEUR_TAB 3000
#define _PI_ 3.14159265359
#define THETA 60

// extern
extern float us_out[6];
extern Timer tps;
extern Ticker ticker_US;

// Prototypes
void captUS_trig();
void captUS_init();

void echoRise1();
void echoFall1();
void echoRise2();
void echoFall2();
void echoRise3();
void echoFall3();
void echoRise4();
void echoFall4();
void echoRise5();
void echoFall5();
void echoRise6();
void echoFall6();

/**********************************
 * Création d'une fonction qui    *
 * convertis le temps en distance *
 **********************************/
float* convertToDistance();


/********************************************
 * nous permet de placer l'origine au coins *
 * de la table                              *
 ********************************************/
void changementBase(double* x_detect, double* y_detect);

/*******************************************
 * nous permet de détecter un obstacle     *
 *                                         *
 * false : personne | true : quelquechoses *
 *******************************************/
bool obstacleSpoted(float dist,double x_robot,double y_robot ,double phi, char I_theta);




#endif // CAPTUS_H
